#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>

#include <linux/radix-tree.h>

static int tree_init(void) {
  
  RADIX_TREE(mytree, GFP_ATOMIC);  /* Declare and initialize */
  
  int a = 5;
  int r;
  int *x;

  int value = 7863;

  r = radix_tree_insert(&mytree, value, &a);
  
  printk("insert result: %d, pointer: %d\n",r,&a);
  
  x = radix_tree_lookup(&mytree, value);
  
  printk("lookup item value %d\n",x);

  return 0;
}

static void tree_exit(void) {
}

module_init(tree_init);
module_exit(tree_exit);
